//VP 2022-2023

class Counter {
var Value: int;

ghost predicate Valid() 
reads this 
{
Value >= 0
}

constructor Init () 
ensures Value == 0
{ Value := 0;}

method GetValue() returns (x: int) 
	ensures x == Value
	requires Valid()
	ensures Valid()
{x:= Value;}

method Inc () 
	modifies this ;
	requires Valid()
	ensures Valid()
 ensures Value == old(Value)+1
 {Value := Value + 1;}

 method Dec ( ) 
	modifies this
	requires Valid()
	ensures Valid()
	requires Value > 0
  ensures Value == old ( Value ) -1
  {Value := Value -1;}
}

method Main ( ) {
	var c := new Counter.Init();
	c.Inc();
	c.Inc();
  c.Dec();
  c.Inc();
assert c.Value == 2;
print(c.Value);
}
