
//VP 2022=2023
type T = int // needs to fix T, to allow doing new T[cap] 

class Stack
{
    const elems: array<T>;
    var size : nat; // current size (used)
 
    constructor (capacity: nat)
    {
        elems := new T[capacity];
        size := 0; 
    }

    predicate  {:verify false} isEmpty()
    {
        size == 0
    }

    predicate  {:verify false} isFull()
    {
        size == elems.Length
    }

    method {:verify false} push(x : T)
    {
        elems[size] := x;
        size := size + 1;
    }

    function   {:verify false} top() : T
    {
         elems[size-1]
    }
    
    method  {:verify false} pop() 
     modifies this
    {
         size := size-1;
    }
}

// A simple test case to check on the console.
method {:verify false} testStack()
{
    var s := new Stack(3);
    assert s.isEmpty();
    s.push(1);
    s.push(2);
    s.push(3);
    assert s.top() == 3;
    assert s.isFull();
    s.pop();
    assert s.top() == 2;
}
